unit IDEMimicU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, HeapMonitorUnit;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    FCaption: TCaption;
    procedure SetCaption(const Value: TCaption);
    { Private declarations }
  public
    //Application OnIdle event handler
    procedure DoIdle(Sender: TObject; var Done: Boolean);
    //Replacement form Caption property
    property Caption: TCaption read FCaption write SetCaption;
  end;

var
  Form1: TForm1;

implementation

uses IDEMimicU2, IDEMimicU3;

{$R *.DFM}

//When Caption is written to, the value is stored in FCaption
//The real form caption gets the extra information written to it
procedure TForm1.SetCaption(const Value: TCaption);
var
  S: String;
begin
  S := MakeCaption(Value);
  if inherited Caption <> S then
  begin
    FCaption := Value;
    inherited Caption := S;
  end
end;

procedure TForm1.DoIdle(Sender: TObject; var Done: Boolean);
begin
  //Get Caption to update its memory display
  Caption := Caption
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Get fake caption initialised
  Caption := inherited Caption;
  //Ensure caption gets updated
  Application.OnIdle := DoIdle
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  Caption := (Sender as TEdit).Text
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with TForm2.Create(nil) do
    try
      ShowModal
    finally
      Free
    end
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TForm3.Create(Application).Show
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  P: Pointer;
begin
  GetMem(P, 1000);
end;

end.
