unit DynamicArrayEgU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls;

type
  TMainForm = class(TForm)
    ListBox1: TListBox;
    btnResizeArray: TButton;
    btnFillArray: TButton;
    btnInfo: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnResizeArrayClick(Sender: TObject);
    procedure btnFillArrayClick(Sender: TObject);
    procedure btnInfoClick(Sender: TObject);
  private
    MyArray: array of Integer;
    procedure DisplayArray;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SetLength(MyArray, StrToInt(InputBox(
      'Enter your array dimensions',
      'Number of elements:', '10')));
  btnFillArray.Click; { Pretend to push the array filling button }
  DisplayArray
end;

procedure TMainForm.btnResizeArrayClick(Sender: TObject);
begin
  SetLength(MyArray, StrToInt(InputBox(
    'Enter your new array dimensions',
    'Number of elements:', '20')));
  DisplayArray
end;

procedure TMainForm.btnFillArrayClick(Sender: TObject);
var
  Loop: Integer;
begin
  for Loop := Low(MyArray) to High(MyArray) do
    MyArray[Loop] := Loop;
  DisplayArray
end;

procedure TMainForm.DisplayArray;
var
  Loop: Integer;
begin
  with ListBox1, Items do
  begin
    BeginUpdate;
    try
      Clear;
      for Loop := Low(MyArray) to High(MyArray) do
        Add(IntToStr(MyArray[Loop]));
      ItemIndex := High(MyArray)
    finally
      EndUpdate
    end
  end
end;

procedure TMainForm.btnInfoClick(Sender: TObject);
begin
  ShowMessageFmt('Array has %d elements, from %d to %d',
    [Length(MyArray), Low(MyArray), High(MyArray)])
end;

end.
 